package Ex_2; 


class Entry {
	/*@ readonly @*/ Object element;
	/*@ peer @*/ Entry previous, next;

    Entry( /*@ readonly @*/ Object o, /*@ peer @*/  Entry p, /*@ peer @*/  Entry n ) {
	element = o;
	previous = p;
	next = n;
    }
}

public class LinkedList {

    private /*@ rep @*/ Entry header;	
	

    public LinkedList() {    	
    	Init();
    }    
    
    protected void Init() {    	
    	header = new /*@ rep @*/ Entry(null, null, null);
    	header.next = header;
    	header.previous = header;
    }

    public void add(/*@ readonly @*/ Object o) {    	
    	Entry newEntry = new /*@ rep @*/ Entry(o, header.previous, header);
        header.previous.next = newEntry;
        header.previous = newEntry;
    }
    
    public boolean isEmpty() {
        return header.next == header;
    }

    protected /*@ readonly @*/ Entry getHeader() {
        return header;
    }
    
    public void merge(/*@ peer @*/  LinkedList other) {
        if (other.isEmpty()) {
            return;
        }
        
        /*@ readonly @*/ Entry entry = other.getHeader().next;
        
        while(entry != other.getHeader()){
        	add(entry.element);
        	entry = entry.next; 
        }

        other.Init();
    }
    
        
    public void println() {
	System.out.print("[ ");

		Entry current = header.next;
        while (current != header) {
	    System.out.print(current.element + " ");
            current = current.next;
        }

        System.out.println("]");
    }

    public static void main(String[] args) {
        System.out.println("concatenate:");
    	LinkedList l1 = new LinkedList();
        l1.add(new Integer(1));        
        l1.add(new Integer(2));
        l1.add(new Integer(3));
        l1.println(); // [ 1 2 3 ]

        
        LinkedList l2 = new LinkedList();
        l2.add(new Integer(4));
        l2.add(new Integer(5));
        l2.println(); // [ 4 5 ]

        l1.merge	(l2);
        l1.println(); // [ 1 2 3 4 5 ]
        l2.println(); // [ ]
           
    }    

}